## serd 0~svn155

=== wscript ===
#!/usr/bin/env python
import filecmp
import glob
import os
import shutil
import subprocess

from waflib.extras import autowaf as autowaf
import waflib.Logs as Logs, waflib.Options as Options

# Version of this package (even if built as a child)
SERD_VERSION       = '0.2.0'
SERD_MAJOR_VERSION = '0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Serd uses the same version number for both library and package
SERD_LIB_VERSION = SERD_VERSION

# Variables for 'waf dist'
APPNAME = 'serd'
VERSION = SERD_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)
    opt.add_option('--no-utils', action='store_true', default=False, dest='no_utils',
                    help="Do not build command line utilities")
    opt.add_option('--test', action='store_true', default=False, dest='build_tests',
                    help="Build unit tests")
    opt.add_option('--stack-check', action='store_true', default=False, dest='stack_check',
                    help="Include runtime stack sanity checks")

def configure(conf):
    conf.line_just = max(conf.line_just, 59)
    autowaf.configure(conf)
    autowaf.display_header('Serd Configuration')

    conf.load('compiler_cc')
    conf.env.append_value('CFLAGS', '-std=c99')

    conf.env['BUILD_TESTS'] = Options.options.build_tests
    conf.env['BUILD_UTILS'] = not Options.options.no_utils

    if Options.options.stack_check:
        autowaf.define(conf, 'SERD_STACK_CHECK', SERD_VERSION)

    autowaf.define(conf, 'SERD_VERSION', SERD_VERSION)
    conf.write_config_header('serd-config.h', remove=False)

    conf.env['SERD_CFLAGS'] = '-I%s/serd-%s' % (
        conf.env['INCLUDEDIR'], SERD_MAJOR_VERSION);
    conf.env['SERD_LIBS'] = '-L%s -lserd-%s' % (
        conf.env['LIBDIR'], SERD_MAJOR_VERSION);

    autowaf.display_msg(conf, "Utilities", str(conf.env['BUILD_UTILS']))
    autowaf.display_msg(conf, "Unit tests", str(conf.env['BUILD_TESTS']))
    print('')

def build(bld):
    # C Headers
    includedir = '${INCLUDEDIR}/serd-%s/serd' % SERD_MAJOR_VERSION
    bld.install_files(includedir, bld.path.ant_glob('serd/*.h'))

    # Pkgconfig file
    autowaf.build_pc(bld, 'SERD', SERD_VERSION, SERD_MAJOR_VERSION, [],
                     {'SERD_CFLAGS'        : bld.env['SERD_CFLAGS'],
                      'SERD_LIBS'          : bld.env['SERD_LIBS'],
                      'SERD_MAJOR_VERSION' : SERD_MAJOR_VERSION})

    lib_source = '''
            src/env.c
            src/node.c
            src/reader.c
            src/uri.c
            src/writer.c
    '''

    # Library
    obj = bld(features = 'c cshlib')
    obj.export_includes = ['.']
    obj.source          = lib_source
    obj.includes        = ['.', './src']
    obj.name            = 'libserd'
    obj.target          = 'serd-%s' % SERD_MAJOR_VERSION
    obj.vnum            = SERD_LIB_VERSION
    obj.install_path    = '${LIBDIR}'
    obj.cflags          = [ '-fvisibility=hidden', '-DSERD_SHARED', '-DSERD_INTERNAL' ]

    if bld.env['BUILD_TESTS']:
        # Static library (for unit test code coverage)
        obj = bld(features = 'c cstlib')
        obj.source       = lib_source
        obj.includes     = ['.', './src']
        obj.name         = 'libserd_static'
        obj.target       = 'serd_static'
        obj.install_path = ''
        obj.cflags       = [ '-fprofile-arcs',  '-ftest-coverage' ]

        # Unit test program
        obj = bld(features = 'c cprogram')
        obj.source       = 'src/serdi.c'
        obj.includes     = ['.', './src']
        obj.use          = 'libserd_static'
        obj.linkflags    = '-lgcov'
        obj.target       = 'serdi_static'
        obj.install_path = ''
        obj.cflags       = [ '-fprofile-arcs',  '-ftest-coverage' ]

    # Utilities
    if bld.env['BUILD_UTILS']:
        obj = bld(features = 'c cprogram')
        obj.source       = 'src/serdi.c'
        obj.includes     = ['.', './src']
        obj.use          = 'libserd'
        obj.target       = 'serdi'
        obj.install_path = '${BINDIR}'

    # Documentation
    autowaf.build_dox(bld, 'SERD', SERD_VERSION, top, out)

    # Man page
    bld.install_files('${MANDIR}/man1', 'doc/serdi.1')

    bld.add_post_fun(autowaf.run_ldconfig)

def lint(ctx):
    subprocess.call('cpplint.py --filter=-whitespace,+whitespace/comments,-build/header_guard,-readability/casting,-readability/todo src/* serd/*', shell=True)

def amalgamate(ctx):
    shutil.copy('serd/serd.h', 'build/serd-%s.h' % SERD_VERSION)
    amalgamation = open('build/serd-%s.c' % SERD_VERSION, 'w')

    serd_internal_h = open('src/serd_internal.h')
    for l in serd_internal_h:
        if l == '#include "serd/serd.h"\n':
            amalgamation.write('#include "serd-%s.h"\n' % SERD_VERSION)
        else:
            amalgamation.write(l)
    serd_internal_h.close()

    for f in 'env.c node.c reader.c uri.c writer.c'.split():
        fd = open('src/' + f)
        amalgamation.write('\n/**\n * @file %s\n */\n' % f)
        header = True
        for l in fd:
            if header:
                if l == '*/\n':
                    header = False
            else:
                if l != '#include "serd_internal.h"\n':
                    amalgamation.write(l)
        fd.close()

    amalgamation.close()

def fix_docs(ctx):
    try:
        os.chdir('build/doc/html')
        os.system("sed -i 's/SERD_API //' group__serd.html")
        os.system("sed -i 's/SERD_DEPRECATED //' group__serd.html")
        os.remove('index.html')
        os.symlink('group__serd.html',
                   'index.html')
    except Exception, e:
        Logs.error("Failed to fix up Doxygen documentation (%s)\n" % e)

def upload_docs(ctx):
    os.system("rsync -avz --delete -e ssh build/doc/html/* drobilla@drobilla.net:~/drobilla.net/docs/serd")

def test(ctx):
    blddir = ""
    top_level = (len(ctx.stack_path) > 1)
    if top_level:
        blddir = 'build/serd/tests'
    else:
        blddir = 'build/tests'

    try:
        os.makedirs(blddir)
    except:
        pass

    for i in glob.glob('build/tests/*.*'):
        os.remove(i)

    srcdir   = ctx.path.abspath()
    orig_dir = os.path.abspath(os.curdir)

    os.chdir(srcdir)

    good_tests = glob.glob('tests/test-*.ttl')
    good_tests.sort()

    bad_tests = glob.glob('tests/bad-*.ttl')
    bad_tests.sort()

    os.chdir(orig_dir)

    autowaf.pre_test(ctx, APPNAME)

    autowaf.run_tests(ctx, APPNAME, [
            './serdi_static file:%s/tests/manifest.ttl > /dev/null' % srcdir,
            './serdi_static file://%s/tests/manifest.ttl > /dev/null' % srcdir,
            './serdi_static %s/tests/UTF-8.ttl > /dev/null' % srcdir,
            './serdi_static -v > /dev/null',
            './serdi_static -s "<foo> a <#Thingie> ." > /dev/null',
            './serdi_static /dev/null > /dev/null'],
                      0, name='serdi-cmd-good')

    autowaf.run_tests(ctx, APPNAME, [
            './serdi_static > /dev/null',
            './serdi_static ftp://example.org/unsupported.ttl > /dev/null',
            './serdi_static -o > /dev/null',
            './serdi_static -z > /dev/null',
            './serdi_static -o illegal > /dev/null',
            './serdi_static /no/such/file > /dev/null'],
                      1, name='serdi-cmd-bad')

    commands = []
    for test in good_tests:
        base_uri = 'http://www.w3.org/2001/sw/DataAccess/df1/' + test
        commands += [ './serdi_static %s/%s \'%s\' > %s.out' % (srcdir, test, base_uri, test) ]

    autowaf.run_tests(ctx, APPNAME, commands, 0, name='good')

    Logs.pprint('BOLD', '\nVerifying turtle => ntriples')
    for test in good_tests:
        out_filename = test + '.out'
        if not os.access(out_filename, os.F_OK):
            Logs.pprint('RED', 'FAIL: %s output is missing' % test)
        elif filecmp.cmp(srcdir + '/' + test.replace('.ttl', '.out'),
                                         test + '.out',
                                         False) != 1:
            Logs.pprint('RED', 'FAIL: %s is incorrect' % out_filename)
        else:
            Logs.pprint('GREEN', 'Pass: %s' % test)

    commands = []
    for test in bad_tests:
        commands += [ './serdi_static %s/%s \'http://www.w3.org/2001/sw/DataAccess/df1/%s\' > %s.out' % (srcdir, test, test, test) ]

    autowaf.run_tests(ctx, APPNAME, commands, 1, name='bad')

    commands = []
    for test in good_tests:
        base_uri = 'http://www.w3.org/2001/sw/DataAccess/df1/' + test
        out_filename = test + '.thru'
        commands += [
                '%s -o turtle %s/%s \'%s\' | %s - \'%s\' > %s.thru' % (
                        './serdi_static', srcdir, test, base_uri,
                        './serdi_static', base_uri, test) ]

    autowaf.run_tests(ctx, APPNAME, commands, 0, name='turtle-round-trip')
    Logs.pprint('BOLD', '\nVerifying ntriples => turtle => ntriples')
    for test in good_tests:
        out_filename = test + '.thru'
        if not os.access(out_filename, os.F_OK):
            Logs.pprint('RED', 'FAIL: %s output is missing' % test)
        elif filecmp.cmp(srcdir + '/' + test.replace('.ttl', '.out'),
                                         test + '.thru',
                                         False) != 1:
            Logs.pprint('RED', 'FAIL: %s is incorrect' % out_filename)
        else:
            Logs.pprint('GREEN', 'Pass: %s' % test)

    autowaf.post_test(ctx, APPNAME)

=== debian/changelog ===
serd (0~svn155-1) unstable; urgency=low

  * New upstream release:
    - Re-licensed under ISC license terms, update debian/copyright.
  * Move from libserd0 to libserd-0-0.
  * Add patch to fix snprintf overflow (Closes: #624775).
  * Refresh 1001-dont_run_ldconfig.patch.
  * debian/rules: Explicitly pass --mandir to configure.
  * debian/get-svn-source.sh
    - Abort on errors.
    - Append upstream versioning to the directory's name.
  * Bump Standards.

 -- Alessio Treglia <alessio@debian.org>  Tue, 03 May 2011 13:57:33 +0200

serd (0~svn128-1) unstable; urgency=low

  * Initial release. (Closes: #619429)

 -- Alessio Treglia <alessio@debian.org>  Wed, 23 Mar 2011 20:45:10 +0100

=== debian/control ===
Source: serd
Section: libs
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alessio Treglia <alessio@debian.org>
Build-Depends: debhelper (>= 7.0.50~),
 pkg-config,
 python
Standards-Version: 3.9.2
Homepage: http://drobilla.net/software/serd/
Vcs-Git: git://git.debian.org/git/pkg-multimedia/serd.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/serd.git

Package: libserd-dev
Section: libdevel
Architecture: all
Depends: libserd-0-0 (>= ${source:Version}),
 libserd-0-0 (<< ${source:Upstream-Version}+1~),
 ${misc:Depends}
Recommends: pkg-config
Description: lightweight RDF syntax library - development files
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package provides the development files for Serd.

Package: libserd-0-0
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Suggests: serdi
Description: lightweight RDF syntax library
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 Serd is not intended to be a swiss-army knife of RDF syntax, but rather
 is suited to resource limited applications, or situations where a simple
 reader/writer with minimal dependencies is ideal (e.g. in LV2 hosts or
 plugins).
 .
 Serd is:
  * small: Serd is implemented in under 2500 lines1 of standard C code.
  * portable and dependency-free: Serd uses only the C standard library,
    and has no external dependencies, making it a lightweight dependency
    in every sense.
  * fast and lightweight: Serd (and the included serdi tool) can be used
    to stream abbreviated Turtle (unlike many other tools which can not
    stream since they must first build an internal model to abbreviate).
    In other words, Serd can re-serialise an unbounded amount of Turtle
    using a fixed amount of memory, preserving the abbreviations in the
    input.
  * conformant and well-tested: Serd is written to the Turtle, NTriples
    and URI specifications, and includes a comprehensive test suite which
    includes all the normative examples from the Turtle specification, all
    the "normal" examples from the URI specification, and additional tests
    added specifically for Serd. The test suite has over 96% code coverage
    (by line), and runs with zero memory errors or leaks.

Package: serdi
Architecture: any
Section: text
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: lightweight RDF syntax library - serdi tool
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package provides the utility 'serdi'.

Package: serd-dbg
Architecture: any
Priority: extra
Section: debug
Depends: serdi (= ${binary:Version}),
 libserd-0-0 (= ${binary:Version}),
 ${misc:Depends}
Description: lightweight RDF syntax library - debugging symbols
 Serd is a lightweight C library for RDF syntax which supports reading
 and writing Turtle and NTriples.
 .
 This package contains the debugging symbols for serd.

=== debian/rules ===
#!/usr/bin/make -f

LDFLAGS+=-Wl,--as-needed
WAF = ./waf

%:
	dh $@

override_dh_auto_configure:
	$(WAF) configure \
		--prefix=/usr \
		--mandir=/usr/share/man \
		--debug

override_dh_auto_build:
	$(WAF)

override_dh_auto_clean:
	$(WAF) distclean
	rm -rf build .waf* get-orig-source
	dh_auto_clean

override_dh_auto_install:
	$(WAF) install --destdir=$(CURDIR)/debian/tmp

override_dh_strip:
	dh_strip --dbg-package=serd-dbg

get-orig-source:
	debian/get-svn-source.sh

## serd 0.4.0

=== wscript ===
--- 
+++ 
@@ -9,7 +9,7 @@
 import waflib.Logs as Logs, waflib.Options as Options
 
 # Version of this package (even if built as a child)
-SERD_VERSION       = '0.2.0'
+SERD_VERSION       = '0.4.0'
 SERD_MAJOR_VERSION = '0'
 
 # Library version (UNIX style major, minor, micro)
@@ -37,8 +37,8 @@
                     help="Include runtime stack sanity checks")
 
 def configure(conf):
-    conf.line_just = max(conf.line_just, 59)
     autowaf.configure(conf)
+    conf.line_just = 13
     autowaf.display_header('Serd Configuration')
 
     conf.load('compiler_cc')
@@ -53,10 +53,10 @@
     autowaf.define(conf, 'SERD_VERSION', SERD_VERSION)
     conf.write_config_header('serd-config.h', remove=False)
 
-    conf.env['SERD_CFLAGS'] = '-I%s/serd-%s' % (
-        conf.env['INCLUDEDIR'], SERD_MAJOR_VERSION);
-    conf.env['SERD_LIBS'] = '-L%s -lserd-%s' % (
-        conf.env['LIBDIR'], SERD_MAJOR_VERSION);
+    conf.env['INCLUDES_SERD'] = ['%s/serd-%s' % (
+        conf.env['INCLUDEDIR'], SERD_MAJOR_VERSION)]
+    conf.env['LIBPATH_SERD'] = [conf.env['LIBDIR']]
+    conf.env['LIB_SERD'] = ['serd-%s' % SERD_MAJOR_VERSION];
 
     autowaf.display_msg(conf, "Utilities", str(conf.env['BUILD_UTILS']))
     autowaf.display_msg(conf, "Unit tests", str(conf.env['BUILD_TESTS']))
@@ -69,9 +69,7 @@
 
     # Pkgconfig file
     autowaf.build_pc(bld, 'SERD', SERD_VERSION, SERD_MAJOR_VERSION, [],
-                     {'SERD_CFLAGS'        : bld.env['SERD_CFLAGS'],
-                      'SERD_LIBS'          : bld.env['SERD_LIBS'],
-                      'SERD_MAJOR_VERSION' : SERD_MAJOR_VERSION})
+                     {'SERD_MAJOR_VERSION' : SERD_MAJOR_VERSION})
 
     lib_source = '''
             src/env.c
@@ -128,9 +126,11 @@
     bld.install_files('${MANDIR}/man1', 'doc/serdi.1')
 
     bld.add_post_fun(autowaf.run_ldconfig)
+    if bld.env['DOCS']:
+        bld.add_post_fun(fix_docs)
 
 def lint(ctx):
-    subprocess.call('cpplint.py --filter=-whitespace,+whitespace/comments,-build/header_guard,-readability/casting,-readability/todo src/* serd/*', shell=True)
+    subprocess.call('cpplint.py --filter=+whitespace/comments,-whitespace/tab,-whitespace/braces,-whitespace/labels,-build/header_guard,-readability/casting,-readability/todo,-build/include src/* serd/*', shell=True)
 
 def amalgamate(ctx):
     shutil.copy('serd/serd.h', 'build/serd-%s.h' % SERD_VERSION)
@@ -161,17 +161,21 @@
 
 def fix_docs(ctx):
     try:
+        top = os.getcwd()
         os.chdir('build/doc/html')
         os.system("sed -i 's/SERD_API //' group__serd.html")
         os.system("sed -i 's/SERD_DEPRECATED //' group__serd.html")
         os.remove('index.html')
         os.symlink('group__serd.html',
                    'index.html')
+        os.chdir(top)
+        os.chdir('build/doc/man/man3')
+        os.system("sed -i 's/SERD_API //' serd.3")
     except Exception, e:
         Logs.error("Failed to fix up Doxygen documentation (%s)\n" % e)
 
 def upload_docs(ctx):
-    os.system("rsync -avz --delete -e ssh build/doc/html/* drobilla@drobilla.net:~/drobilla.net/docs/serd")
+    os.system("rsync -ravz --delete -e ssh build/doc/html/ drobilla@drobilla.net:~/drobilla.net/docs/serd/")
 
 def test(ctx):
     blddir = ""
@@ -209,6 +213,7 @@
             './serdi_static file://%s/tests/manifest.ttl > /dev/null' % srcdir,
             './serdi_static %s/tests/UTF-8.ttl > /dev/null' % srcdir,
             './serdi_static -v > /dev/null',
+            './serdi_static -h > /dev/null',
             './serdi_static -s "<foo> a <#Thingie> ." > /dev/null',
             './serdi_static /dev/null > /dev/null'],
                       0, name='serdi-cmd-good')
@@ -216,9 +221,14 @@
     autowaf.run_tests(ctx, APPNAME, [
             './serdi_static > /dev/null',
             './serdi_static ftp://example.org/unsupported.ttl > /dev/null',
+            './serdi_static -i > /dev/null',
             './serdi_static -o > /dev/null',
             './serdi_static -z > /dev/null',
+            './serdi_static -p > /dev/null',
+            './serdi_static -c > /dev/null',
+            './serdi_static -i illegal > /dev/null',
             './serdi_static -o illegal > /dev/null',
+            './serdi_static -i turtle > /dev/null',
             './serdi_static /no/such/file > /dev/null'],
                       1, name='serdi-cmd-bad')
 
@@ -247,18 +257,21 @@
 
     autowaf.run_tests(ctx, APPNAME, commands, 1, name='bad')
 
+    thru_tests = good_tests
+    thru_tests.remove('tests/test-id.ttl') # IDs are mapped so files won't be identical
+
     commands = []
-    for test in good_tests:
+    for test in thru_tests:
         base_uri = 'http://www.w3.org/2001/sw/DataAccess/df1/' + test
         out_filename = test + '.thru'
         commands += [
-                '%s -o turtle %s/%s \'%s\' | %s - \'%s\' > %s.thru' % (
-                        './serdi_static', srcdir, test, base_uri,
-                        './serdi_static', base_uri, test) ]
-
+            '%s -o turtle -p foo %s/%s \'%s\' | %s -i turtle -c foo - \'%s\' | sed \'s/_:docid/_:genid/g\' > %s.thru' % (
+                './serdi_static', srcdir, test, base_uri,
+                './serdi_static', base_uri, test) ]
+        
     autowaf.run_tests(ctx, APPNAME, commands, 0, name='turtle-round-trip')
     Logs.pprint('BOLD', '\nVerifying ntriples => turtle => ntriples')
-    for test in good_tests:
+    for test in thru_tests:
         out_filename = test + '.thru'
         if not os.access(out_filename, os.F_OK):
             Logs.pprint('RED', 'FAIL: %s output is missing' % test)

=== debian/changelog ===
serd (0.4.0-1) unstable; urgency=low

  * First upstream stable release.
  * Delete 0001-write_text_escape_buf_overflow.patch, applied upstream.
  * Refresh patches.
  * Update symbols file.
  * debian/copyright: Update format spec.
  * Add watch file.
  * Drop unneeded get-svn-source.sh.

 -- Alessio Treglia <alessio@debian.org>  Thu, 26 May 2011 00:07:31 +0200

=== debian/rules ===
--- 
+++ 
@@ -25,6 +25,3 @@
 
 override_dh_strip:
 	dh_strip --dbg-package=serd-dbg
-
-get-orig-source:
-	debian/get-svn-source.sh

## serd 0.4.2

=== wscript ===
--- 
+++ 
@@ -9,7 +9,7 @@
 import waflib.Logs as Logs, waflib.Options as Options
 
 # Version of this package (even if built as a child)
-SERD_VERSION       = '0.4.0'
+SERD_VERSION       = '0.4.2'
 SERD_MAJOR_VERSION = '0'
 
 # Library version (UNIX style major, minor, micro)
@@ -53,8 +53,8 @@
     autowaf.define(conf, 'SERD_VERSION', SERD_VERSION)
     conf.write_config_header('serd-config.h', remove=False)
 
-    conf.env['INCLUDES_SERD'] = ['%s/serd-%s' % (
-        conf.env['INCLUDEDIR'], SERD_MAJOR_VERSION)]
+    conf.env['INCLUDES_SERD'] = ['%s/serd-%s' % (conf.env['INCLUDEDIR'],
+                                                 SERD_MAJOR_VERSION)]
     conf.env['LIBPATH_SERD'] = [conf.env['LIBDIR']]
     conf.env['LIB_SERD'] = ['serd-%s' % SERD_MAJOR_VERSION];
 
@@ -159,38 +159,39 @@
 
     amalgamation.close()
 
+def build_dir(ctx, subdir):
+    if autowaf.is_child():
+        return os.path.join('build', APPNAME, subdir)
+    else:
+        return os.path.join('build', subdir)
+    
 def fix_docs(ctx):
     try:
         top = os.getcwd()
-        os.chdir('build/doc/html')
+        os.chdir(build_dir(ctx, 'doc/html'))
         os.system("sed -i 's/SERD_API //' group__serd.html")
         os.system("sed -i 's/SERD_DEPRECATED //' group__serd.html")
         os.remove('index.html')
         os.symlink('group__serd.html',
                    'index.html')
         os.chdir(top)
-        os.chdir('build/doc/man/man3')
+        os.chdir(build_dir(ctx, 'doc/man/man3'))
         os.system("sed -i 's/SERD_API //' serd.3")
-    except Exception, e:
-        Logs.error("Failed to fix up Doxygen documentation (%s)\n" % e)
+        os.chdir(top)
+    except:
+        Logs.error("Failed to fix up %s documentation" % APPNAME)
 
 def upload_docs(ctx):
     os.system("rsync -ravz --delete -e ssh build/doc/html/ drobilla@drobilla.net:~/drobilla.net/docs/serd/")
 
 def test(ctx):
-    blddir = ""
-    top_level = (len(ctx.stack_path) > 1)
-    if top_level:
-        blddir = 'build/serd/tests'
-    else:
-        blddir = 'build/tests'
-
+    blddir = build_dir(ctx, 'tests')
     try:
         os.makedirs(blddir)
     except:
         pass
 
-    for i in glob.glob('build/tests/*.*'):
+    for i in glob.glob(blddir + '/*.*'):
         os.remove(i)
 
     srcdir   = ctx.path.abspath()

=== debian/changelog ===
serd (0.4.2-1) unstable; urgency=low

  * New upstream bugfix release:
    - Fix compilation issues on some systems.
    - Fix build system Python 3 compatibility.

 -- Alessio Treglia <alessio@debian.org>  Thu, 26 May 2011 09:57:25 +0200

=== debian/watch ===
version=3
http://download.drobilla.net/serd-(.*)\.tar\.bz2

## serd 0.5.0

=== debian/changelog ===
serd (0.5.0-1) unstable; urgency=low

  * New upstream release:
    - Fix pretty printing of successive blank descriptions, i.e. "] , ["
    - Avoid writing illegal Turtle names as a result of URI qualifying
    - Gracefully handle NULL reader sinks
    - Add serd_strerror
    - Add serd_env_set_prefix_from_strings for convenience
    - Fix erroneously equal SERD_ERR_BAD_SYNTAX and SERD_ERR_BAD_ARG
    - Add ability to build static library
  * Update symbols file.

 -- Alessio Treglia <alessio@debian.org>  Sun, 02 Oct 2011 10:35:47 +0200

serd (0.4.2-2) unstable; urgency=low

  * Sources are now taken from download.drobilla.net.
  * Add doxygen,graphviz to Build-Depends-Indep.
  * Add documentation package.
  * Add libserd-doc to libserd-dev's Suggests field.
  * Enable strict flag.

 -- Alessio Treglia <alessio@debian.org>  Fri, 27 May 2011 15:57:32 +0200

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,8 @@
 Build-Depends: debhelper (>= 7.0.50~),
  pkg-config,
  python
+Build-Depends-Indep: doxygen,
+ graphviz
 Standards-Version: 3.9.2
 Homepage: http://drobilla.net/software/serd/
 Vcs-Git: git://git.debian.org/git/pkg-multimedia/serd.git
@@ -18,6 +20,7 @@
  libserd-0-0 (<< ${source:Upstream-Version}+1~),
  ${misc:Depends}
 Recommends: pkg-config
+Suggests: libserd-doc
 Description: lightweight RDF syntax library - development files
  Serd is a lightweight C library for RDF syntax which supports reading
  and writing Turtle and NTriples.
@@ -67,6 +70,17 @@
  .
  This package provides the utility 'serdi'.
 
+Package: libserd-doc
+Section: doc
+Architecture: all
+Enhances: libserd-dev
+Depends: ${misc:Depends}
+Description: lightweight RDF syntax library - documentation
+ Serd is a lightweight C library for RDF syntax which supports reading
+ and writing Turtle and NTriples.
+ .
+ This package provides the developer's reference for serd.
+
 Package: serd-dbg
 Architecture: any
 Priority: extra

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,10 @@
 
 LDFLAGS+=-Wl,--as-needed
 WAF = ./waf
+
+ifeq ($(shell dpkg-query -s doxygen graphviz 1>/dev/null 2>&1 && echo yes),yes)
+CONFIGURE_EXTRA_FLAGS += --docs
+endif
 
 %:
 	dh $@
@@ -10,7 +14,9 @@
 	$(WAF) configure \
 		--prefix=/usr \
 		--mandir=/usr/share/man \
-		--debug
+		--strict \
+		--debug \
+		$(CONFIGURE_EXTRA_FLAGS)
 
 override_dh_auto_build:
 	$(WAF)

## serd 0.5.0+dfsg0

=== wscript ===
--- 
+++ 
@@ -4,12 +4,13 @@
 import os
 import shutil
 import subprocess
+import sys
 
 from waflib.extras import autowaf as autowaf
 import waflib.Logs as Logs, waflib.Options as Options
 
 # Version of this package (even if built as a child)
-SERD_VERSION       = '0.4.2'
+SERD_VERSION       = '0.5.0'
 SERD_MAJOR_VERSION = '0'
 
 # Library version (UNIX style major, minor, micro)
@@ -28,24 +29,27 @@
 out = 'build'
 
 def options(opt):
+    opt.load('compiler_c')
     autowaf.set_options(opt)
     opt.add_option('--no-utils', action='store_true', default=False, dest='no_utils',
-                    help="Do not build command line utilities")
+                   help="Do not build command line utilities")
     opt.add_option('--test', action='store_true', default=False, dest='build_tests',
-                    help="Build unit tests")
+                   help="Build unit tests")
     opt.add_option('--stack-check', action='store_true', default=False, dest='stack_check',
-                    help="Include runtime stack sanity checks")
+                   help="Include runtime stack sanity checks")
+    opt.add_option('--static', action='store_true', default=False, dest='static',
+                   help="Build static library")
 
 def configure(conf):
+    conf.load('compiler_c')
     autowaf.configure(conf)
-    conf.line_just = 13
     autowaf.display_header('Serd Configuration')
 
-    conf.load('compiler_cc')
-    conf.env.append_value('CFLAGS', '-std=c99')
+    conf.env.append_unique('CFLAGS', '-std=c99')
 
     conf.env['BUILD_TESTS'] = Options.options.build_tests
     conf.env['BUILD_UTILS'] = not Options.options.no_utils
+    conf.env['BUILD_STATIC'] = Options.options.static
 
     if Options.options.stack_check:
         autowaf.define(conf, 'SERD_STACK_CHECK', SERD_VERSION)
@@ -73,51 +77,70 @@
 
     lib_source = '''
             src/env.c
+            src/error.c
             src/node.c
             src/reader.c
             src/uri.c
             src/writer.c
     '''
 
-    # Library
-    obj = bld(features = 'c cshlib')
-    obj.export_includes = ['.']
-    obj.source          = lib_source
-    obj.includes        = ['.', './src']
-    obj.name            = 'libserd'
-    obj.target          = 'serd-%s' % SERD_MAJOR_VERSION
-    obj.vnum            = SERD_LIB_VERSION
-    obj.install_path    = '${LIBDIR}'
-    obj.cflags          = [ '-fvisibility=hidden', '-DSERD_SHARED', '-DSERD_INTERNAL' ]
+    libflags = [ '-fvisibility=hidden' ]
+    if sys.platform == 'win32':
+        libflags = []
+
+    # Shared Library
+    obj = bld(features        = 'c cshlib',
+              export_includes = ['.'],
+              source          = lib_source,
+              includes        = ['.', './src'],
+              name            = 'libserd',
+              target          = 'serd-%s' % SERD_MAJOR_VERSION,
+              vnum            = SERD_LIB_VERSION,
+              install_path    = '${LIBDIR}',
+              cflags          = libflags + [ '-DSERD_SHARED',
+                                             '-DSERD_INTERNAL' ])
+
+    # Static library
+    if bld.env['BUILD_STATIC']:
+        obj = bld(features        = 'c cstlib',
+                  export_includes = ['.'],
+                  source          = lib_source,
+                  includes        = ['.', './src'],
+                  name            = 'libserd_static',
+                  target          = 'serd-%s' % SERD_MAJOR_VERSION,
+                  vnum            = SERD_LIB_VERSION,
+                  install_path    = '${LIBDIR}',
+                  cflags          = [ '-DSERD_INTERNAL' ])
 
     if bld.env['BUILD_TESTS']:
         # Static library (for unit test code coverage)
-        obj = bld(features = 'c cstlib')
-        obj.source       = lib_source
-        obj.includes     = ['.', './src']
-        obj.name         = 'libserd_static'
-        obj.target       = 'serd_static'
-        obj.install_path = ''
-        obj.cflags       = [ '-fprofile-arcs',  '-ftest-coverage' ]
+        obj = bld(features     = 'c cstlib',
+                  source       = lib_source,
+                  includes     = ['.', './src'],
+                  name         = 'libserd_profiled',
+                  target       = 'serd_profiled',
+                  install_path = '',
+                  cflags       = [ '-fprofile-arcs', '-ftest-coverage',
+                                   '-DSERD_INTERNAL' ])
 
         # Unit test program
-        obj = bld(features = 'c cprogram')
-        obj.source       = 'src/serdi.c'
-        obj.includes     = ['.', './src']
-        obj.use          = 'libserd_static'
-        obj.linkflags    = '-lgcov'
-        obj.target       = 'serdi_static'
-        obj.install_path = ''
-        obj.cflags       = [ '-fprofile-arcs',  '-ftest-coverage' ]
+        obj = bld(features     = 'c cprogram',
+                  source       = 'src/serdi.c',
+                  includes     = ['.', './src'],
+                  use          = 'libserd_profiled',
+                  linkflags    = '-lgcov',
+                  target       = 'serdi_static',
+                  install_path = '',
+                  cflags       = [ '-fprofile-arcs',  '-ftest-coverage' ])
 
     # Utilities
     if bld.env['BUILD_UTILS']:
-        obj = bld(features = 'c cprogram')
-        obj.source       = 'src/serdi.c'
-        obj.includes     = ['.', './src']
-        obj.use          = 'libserd'
-        obj.target       = 'serdi'
-        obj.install_path = '${BINDIR}'
+        obj = bld(features     = 'c cprogram',
+                  source       = 'src/serdi.c',
+                  includes     = ['.', './src'],
+                  use          = 'libserd',
+                  target       = 'serdi',
+                  install_path = '${BINDIR}')
 
     # Documentation
     autowaf.build_dox(bld, 'SERD', SERD_VERSION, top, out)
@@ -164,7 +187,7 @@
         return os.path.join('build', APPNAME, subdir)
     else:
         return os.path.join('build', subdir)
-    
+
 def fix_docs(ctx):
     try:
         top = os.getcwd()
@@ -209,34 +232,36 @@
 
     autowaf.pre_test(ctx, APPNAME)
 
+    os.environ['PATH'] = '.' + os.pathsep + os.getenv('PATH')
+    nul = os.devnull
     autowaf.run_tests(ctx, APPNAME, [
-            './serdi_static file:%s/tests/manifest.ttl > /dev/null' % srcdir,
-            './serdi_static file://%s/tests/manifest.ttl > /dev/null' % srcdir,
-            './serdi_static %s/tests/UTF-8.ttl > /dev/null' % srcdir,
-            './serdi_static -v > /dev/null',
-            './serdi_static -h > /dev/null',
-            './serdi_static -s "<foo> a <#Thingie> ." > /dev/null',
-            './serdi_static /dev/null > /dev/null'],
+            'serdi_static file:%s/tests/manifest.ttl > %s' % (srcdir, nul),
+            'serdi_static file://%s/tests/manifest.ttl > %s' % (srcdir, nul),
+            'serdi_static %s/tests/UTF-8.ttl > %s' % (srcdir, nul),
+            'serdi_static -v > %s' % nul,
+            'serdi_static -h > %s' % nul,
+            'serdi_static -s "<foo> a <#Thingie> ." > %s' % nul,
+            'serdi_static %s > %s' % (nul, nul)],
                       0, name='serdi-cmd-good')
 
     autowaf.run_tests(ctx, APPNAME, [
-            './serdi_static > /dev/null',
-            './serdi_static ftp://example.org/unsupported.ttl > /dev/null',
-            './serdi_static -i > /dev/null',
-            './serdi_static -o > /dev/null',
-            './serdi_static -z > /dev/null',
-            './serdi_static -p > /dev/null',
-            './serdi_static -c > /dev/null',
-            './serdi_static -i illegal > /dev/null',
-            './serdi_static -o illegal > /dev/null',
-            './serdi_static -i turtle > /dev/null',
-            './serdi_static /no/such/file > /dev/null'],
+            'serdi_static > %s' % nul,
+            'serdi_static ftp://example.org/unsupported.ttl > %s' % nul,
+            'serdi_static -i > %s' % nul,
+            'serdi_static -o > %s' % nul,
+            'serdi_static -z > %s' % nul,
+            'serdi_static -p > %s' % nul,
+            'serdi_static -c > %s' % nul,
+            'serdi_static -i illegal > %s' % nul,
+            'serdi_static -o illegal > %s' % nul,
+            'serdi_static -i turtle > %s' % nul,
+            'serdi_static /no/such/file > %s' % nul],
                       1, name='serdi-cmd-bad')
 
     commands = []
     for test in good_tests:
         base_uri = 'http://www.w3.org/2001/sw/DataAccess/df1/' + test
-        commands += [ './serdi_static %s/%s \'%s\' > %s.out' % (srcdir, test, base_uri, test) ]
+        commands += [ 'serdi_static %s/%s \'%s\' > %s.out' % (srcdir, test, base_uri, test) ]
 
     autowaf.run_tests(ctx, APPNAME, commands, 0, name='good')
 
@@ -254,7 +279,7 @@
 
     commands = []
     for test in bad_tests:
-        commands += [ './serdi_static %s/%s \'http://www.w3.org/2001/sw/DataAccess/df1/%s\' > %s.out' % (srcdir, test, test, test) ]
+        commands += [ 'serdi_static %s/%s \'http://www.w3.org/2001/sw/DataAccess/df1/%s\' > %s.out' % (srcdir, test, test, test) ]
 
     autowaf.run_tests(ctx, APPNAME, commands, 1, name='bad')
 
@@ -267,9 +292,9 @@
         out_filename = test + '.thru'
         commands += [
             '%s -o turtle -p foo %s/%s \'%s\' | %s -i turtle -c foo - \'%s\' | sed \'s/_:docid/_:genid/g\' > %s.thru' % (
-                './serdi_static', srcdir, test, base_uri,
-                './serdi_static', base_uri, test) ]
-        
+                'serdi_static', srcdir, test, base_uri,
+                'serdi_static', base_uri, test) ]
+
     autowaf.run_tests(ctx, APPNAME, commands, 0, name='turtle-round-trip')
     Logs.pprint('BOLD', '\nVerifying ntriples => turtle => ntriples')
     for test in thru_tests:

=== debian/changelog ===
serd (0.5.0+dfsg0-2) unstable; urgency=low

  * Build with MultiArch.

 -- Alessio Treglia <alessio@debian.org>  Tue, 24 Jan 2012 09:36:42 +0100

serd (0.5.0+dfsg0-1) unstable; urgency=low

  * Repack upstream tarball to get rid of waf blob (Closes: #654501).
  * Adjust the clean target to properly clean the sources tree.

 -- Alessio Treglia <alessio@debian.org>  Tue, 10 Jan 2012 01:23:34 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
 Uploaders: Alessio Treglia <alessio@debian.org>
-Build-Depends: debhelper (>= 7.0.50~),
+Build-Depends: debhelper (>= 8.1.3~),
  pkg-config,
  python
 Build-Depends-Indep: doxygen,
@@ -15,9 +15,10 @@
 
 Package: libserd-dev
 Section: libdevel
-Architecture: all
-Depends: libserd-0-0 (>= ${source:Version}),
- libserd-0-0 (<< ${source:Upstream-Version}+1~),
+Architecture: any
+Multi-Arch: same
+Depends:
+ libserd-0-0 (= ${binary:Version}),
  ${misc:Depends}
 Recommends: pkg-config
 Suggests: libserd-doc
@@ -29,6 +30,8 @@
 
 Package: libserd-0-0
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends},
  ${misc:Depends}
 Suggests: serdi
@@ -83,6 +86,7 @@
 
 Package: serd-dbg
 Architecture: any
+Multi-Arch: same
 Priority: extra
 Section: debug
 Depends: serdi (= ${binary:Version}),

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #!/usr/bin/make -f
 
+DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 LDFLAGS+=-Wl,--as-needed
 WAF = ./waf
 
@@ -14,6 +15,7 @@
 	$(WAF) configure \
 		--prefix=/usr \
 		--mandir=/usr/share/man \
+		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
 		--strict \
 		--debug \
 		$(CONFIGURE_EXTRA_FLAGS)
@@ -22,8 +24,9 @@
 	$(WAF)
 
 override_dh_auto_clean:
-	$(WAF) distclean
-	rm -rf build .waf* get-orig-source
+	$(WAF) clean || true
+	find -name "*.pyc" -delete
+	rm -rf build .waf*
 	dh_auto_clean
 
 override_dh_auto_install:
